package repository

import (
	"time"

	"be.ems/src/framework/datasource"
	"be.ems/src/framework/logger"
	"be.ems/src/modules/network_element/model"
)

// 实例化数据层 NeInfo 结构体
var NewNeInfo = &NeInfo{}

// NeInfo 网元信息表 数据层处理
type NeInfo struct{}

// neListSort 网元列表预设排序
func (r NeInfo) neListSort(arr []model.NeInfo) []model.NeInfo {
	// neListSort 网元列表预设排序
	var list = []string{
		"OMC",
		"IMS",
		"AMF",
		"AUSF",
		"UDR",
		"UDM",
		"SMF",
		"PCF",
		"NSSF",
		"NRF",
		"UPF",
		"LMF",
		"NEF",
		"MME",
		"N3IWF",
		"MOCNGW",
		"SMSC",
		"SMSF",
		"CBC",
		"CHF",
		"HLR",
		"SGWC",
	}

	// 创建优先级映射
	priority := make(map[string]int)
	for i, v := range list {
		priority[v] = i
	}
	// 冒泡排序
	n := len(arr)
	for i := 0; i < n-1; i++ {
		for j := 0; j < n-i-1; j++ {
			if priority[arr[j].NeType] > priority[arr[j+1].NeType] {
				// 交换元素
				arr[j], arr[j+1] = arr[j+1], arr[j]
			}
		}
	}
	return arr
}

// SelectByPage 分页查询集合
func (r NeInfo) SelectByPage(query map[string]string) ([]model.NeInfo, int64) {
	tx := datasource.DB("").Model(&model.NeInfo{})
	// 查询条件拼接
	if v, ok := query["neType"]; ok && v != "" {
		tx = tx.Where("ne_type = ?", v)
	}
	if v, ok := query["neId"]; ok && v != "" {
		tx = tx.Where("ne_id = ?", v)
	}
	if v, ok := query["rmUid"]; ok && v != "" {
		tx = tx.Where("rmUid like concat(?, '%')", v)
	}

	// 查询结果
	var total int64 = 0
	rows := []model.NeInfo{}

	// 查询数量为0直接返回
	if err := tx.Count(&total).Error; err != nil || total <= 0 {
		return rows, total
	}

	// 查询数据分页
	pageNum, pageSize := datasource.PageNumSize(query["pageNum"], query["pageSize"])
	tx = tx.Limit(pageSize).Offset(pageSize * pageNum)
	err := tx.Order("ne_type asc, ne_id asc").Find(&rows).Error
	if err != nil {
		logger.Errorf("query find err => %v", err.Error())
		return rows, total
	}
	return r.neListSort(rows), total
}

// SelectNeInfoByNeTypeAndNeID 通过ne_type和ne_id查询网元信息
func (r NeInfo) SelectNeInfoByNeTypeAndNeID(neType, neID string) model.NeInfo {
	tx := datasource.DB("").Model(&model.NeInfo{})
	// 构建查询条件
	tx = tx.Where("ne_type = ? and ne_id = ?", neType, neID)
	// 查询数据
	row := model.NeInfo{}
	if err := tx.Limit(1).Find(&row).Error; err != nil {
		logger.Errorf("query find err => %v", err.Error())
		return row
	}
	return row
}

// SelectList 查询列表
func (r NeInfo) SelectList(neInfo model.NeInfo) []model.NeInfo {
	tx := datasource.DB("").Model(&model.NeInfo{})
	// 构建查询条件
	if neInfo.NeType != "" {
		tx = tx.Where("ne_type = ?", neInfo.NeType)
	}
	if neInfo.NeId != "" {
		tx = tx.Where("ne_id = ?", neInfo.NeId)
	}

	// 查询数据
	rows := []model.NeInfo{}
	if err := tx.Order("ne_type asc, ne_id asc").Find(&rows).Error; err != nil {
		logger.Errorf("query find err => %v", err.Error())
		return rows
	}
	return r.neListSort(rows)
}

// SelectByIds 通过ID查询
func (r NeInfo) SelectByIds(ids []string) []model.NeInfo {
	rows := []model.NeInfo{}
	if len(ids) <= 0 {
		return rows
	}
	tx := datasource.DB("").Model(&model.NeInfo{})
	// 构建查询条件
	tx = tx.Where("id in ?", ids)
	// 查询数据
	if err := tx.Find(&rows).Error; err != nil {
		logger.Errorf("query find err => %v", err.Error())
		return rows
	}
	return rows
}

// CheckUniqueNeTypeAndNeId 校验同类型下标识是否唯一
func (r NeInfo) CheckUniqueNeTypeAndNeId(neInfo model.NeInfo) string {
	tx := datasource.DB("").Model(&model.NeInfo{})
	// 查询条件拼接
	if neInfo.NeType != "" {
		tx = tx.Where("ne_type = ?", neInfo.NeType)
	}
	if neInfo.NeId != "" {
		tx = tx.Where("ne_id = ?", neInfo.NeType)
	}
	// 查询数据
	id := ""
	if err := tx.Limit(1).Select("id").Find(&id).Error; err != nil {
		logger.Errorf("query find err => %v", err.Error())
		return id
	}
	return id
}

// Insert 新增信息
func (r *NeInfo) Insert(neInfo model.NeInfo) string {
	if neInfo.CreateBy != "" {
		ms := time.Now().UnixMilli()
		neInfo.CreateTime = ms
		neInfo.UpdateTime = ms
		neInfo.UpdateBy = neInfo.CreateBy
	}
	tx := datasource.DefaultDB().Create(&neInfo)
	if err := tx.Error; err != nil {
		logger.Errorf("CreateInBatches err => %v", err)
	}
	return neInfo.ID
}

// Update 修改信息
func (r *NeInfo) Update(neInfo model.NeInfo) int64 {
	if neInfo.ID == "" {
		return 0
	}
	if neInfo.UpdateBy != "" {
		neInfo.UpdateTime = time.Now().UnixMilli()
	}
	neInfo.UpdateTime = time.Now().UnixMilli()
	tx := datasource.DB("").Model(&model.NeInfo{})
	// 构建查询条件
	tx = tx.Where("id = ?", neInfo.ID)
	tx = tx.Omit("id")
	// 执行更新
	if err := tx.Updates(neInfo).Error; err != nil {
		logger.Errorf("update err => %v", err.Error())
		return 0
	}
	return tx.RowsAffected
}

// Update 修改信息
func (r *NeInfo) UpdateState(id, status string) int64 {
	if id == "" {
		return 0
	}
	tx := datasource.DB("").Model(&model.NeInfo{})
	// 构建查询条件
	tx = tx.Where("id = ?", id)
	// 执行更新
	if err := tx.UpdateColumn("status", status).Error; err != nil {
		logger.Errorf("update err => %v", err.Error())
		return 0
	}
	return tx.RowsAffected
}

// DeleteByIds 批量删除网元信息
func (r NeInfo) DeleteByIds(ids []string) int64 {
	if len(ids) <= 0 {
		return 0
	}
	tx := datasource.DB("").Where("id in ?", ids)
	if err := tx.Delete(&model.NeInfo{}).Error; err != nil {
		logger.Errorf("delete err => %v", err.Error())
		return 0
	}
	return tx.RowsAffected
}
